Subject: Class Loader fails if entry in class cache is discarded
Description

Steps to reproduce:

    -  rm -rf typo3temp/Cache/
    -  do a (e.g. FE-) request to populate caches
    -  rm typo3temp/Cache/Data/cache_classes/psr_log_loggerinterface

After that you get a fatal error for every request.

This is the case because autoload registry and aliases only populate this cache if the package states change.
Having a volatile cache for cache_classes (like memcache or APC) will sooner or later lead to a fatal error, which is not acceptable.

Idea: Introduce a two level cache for cache_classes that has persistent (file) second level cache and a potentially volatile and fast first
level cache.

Related issues:
related to Core - Task # 54990: ClassLoader cache ist too slow, no matter whi... Resolved 2014-01-14
related to Core - Bug # 55099: PHP Warnings after clearing configuration cach... Resolved 2014-01-17
related to Core - Bug # 54906: Fatal error: Interface 'Psr\Log\LoggerInterfac... Resolved 2014-03-12 2014-03-12
related to Core - Task # 54984: "Clear all caches" makes the site unavailable... Closed 2014-01-14
related to Core - Bug # 54004: Extension checker does not use the autoloader? Resolved 2013-11-27

History
#1 - 2014-01-15 16:56 - Helmut Hummel
- Status changed from New to Accepted

#2 - 2014-03-07 09:54 - Alexander Opitz

The described problem is for every Aliased class.

Non aliased classes can be loaded and the cache entry is regenerated, but if there are aliases for this class they don't get saved into the cache file,
this information got lost and can lead to problems with "instanceof" code parts.

But the problem is very hard and this over 2000 class aliases costs us much time. :-(

#3 - 2015-07-16 10:39 - Benjamin Mack
- Status changed from Accepted to Closed
